**🚨 This project is still in very early stages and is not stable, _use at your own risk_! 🚨**

<p align="center">
  <img width="400px" src="./assets/pulumi.svg" alt="Pulumi" />
</p>

<p>
  <img height="128" src="./assets/checkly.svg" align="right" />
  <h1>Checkly Pulumi Provider</h1>
</p>

> 🟪 Pulumi provider for the [Checkly](https://checklyhq.com) Delightful Active Monitoring

<br>

## 🪛 Installing

This package is available for several languages/platforms:

### Node.js (JavaScript/TypeScript)

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```bash
npm install @pulumi/checkly
```

or `yarn`:

```bash
yarn add @pulumi/checkly
```

### Python

To use from Python, install using `pip`:

```bash
pip install pulumi_checkly
```

### Go

To use from Go, use `go get` to grab the latest version of the library:

```bash
go get github.com/pulumi/pulumi-checkly/sdk/go/...
```

### .NET

To use from .NET, install using `dotnet add package`:

```bash
dotnet add package Pulumi.Checkly
```

<br>

## ⚙️  Configuration

The following configuration points are available for the `foo` provider:

- `checkly:apiKey` (environment: `CHECKLY_API_KEY`) - the Checkly API Key.
- `checkly:accountId` (environment: `CHECKLY_ACCOUNT_ID`) - the Checkly account ID.

<br>

## 📖 Reference

For detailed reference documentation, please visit [the Pulumi registry](https://www.pulumi.com/registry/packages/checkly/api-docs/).

<br>

## 📄 License

[MIT](https://github.com/checkly/pulumi-checkly/blob/main/LICENSE)

<br>


<p align="center">
  <a href="https://checklyhq.com?utm_source=github&utm_medium=sponsor-logo-github&utm_campaign=headless-recorder" target="_blank">
  <img width="100px" src="https://www.checklyhq.com/images/text_racoon_logo.svg" alt="Checkly" />
  </a>
  <br />
  <i><sub>Delightful Active Monitoring for Developers</sub></i>
  <br>
  <b><sub>From Checkly with ♥️</sub></b>
<p>
